<?php
if(!defined('BASEPATH')){
	define('BASEPATH', dirname(dirname(__FILE__)) . '/');
}
include(BASEPATH . 'system/init.php');

set_time_limit(0);

$db->update('server_index', array('status' => 2), array('status' => 1));

foreach($servers as $server){
	#echo '<pre>' . print_r($server, true) . '</pre>';
	if(!isset($server['extension'])){
		$logger->log('Server config: Extension not specified');
	}

	$ext_name	= strtolower($server['extension']);
	$ext_path 	= BASEPATH . 'extensions/' . $server['extension'];

	if(!is_dir($ext_path)){
		$logger->log("Server config: Extension '" . $ext_name . "' not found");
	}

	# Add To Server Index
	$db->insert_update('server_index', array(
			'status'				=> 1,
			'server_id'				=> $server['id'], 
			'extension'				=> $server['extension'],
			'name'					=> $server['name'],
			'mods'					=> (isset($server['mods']) ? (is_array($server['mods']) ? implode(',', $server['mods']) : $server['mods']) : ''),
		), array(
			'status'				=> true,
			'extension'				=> true,
			'name'					=> true,
			'mods'					=> true,
		));
	
	foreach($server as $field=>$value){
		if(!in_array($field, array('id', 'extension', 'name', 'mods'))){
			$db->insert_update('server_meta', array(
					'server_id'		=> $server['id'], 
					'type'			=> 'config',
					'field'			=> $field,
					'value'			=> $value,
				), array(
					'value'			=> true,
				));
		}
	}
	
	# Load Software Exporter
	require_once($ext_path . '/exporter.php');
	$classname = $ext_name . '_exporter';
	$extension = new $classname();
	$extension->db = $db;	# TODO user super controller
	
	require_once(BASEPATH . 'system/libs/db_store.php');
	$extension->store = new db_store();
	$extension->store->db = $db;	# TODO user super controller
	
	$extension->export($server);
}

$db->update('server_index', array('status' => 0), array('status' => 2));

