<?php
/*
 * Essentialschat
 * Bukkit/Spigot Plugin
 * https://dev.bukkit.org/bukkit-plugins/essentials/files/?sort=date
 */
class Minecraft_mod_essentialschat{
	private $server			= array();			# Current server settings loaded
	
	function __construct($server=array()) {
		$this->server = $server;
	}
	
	function option($field, $default=false){
		if(isset($this->server['metadata'][$field])){
			return $this->server['metadata'][$field];
		} else if(isset($this->server[$field])){
			return $this->server[$field];
		}

		return $default;
	}
		
	/* ============================================================
	 * CHAT
	 * ------------------------------------------------------------
	 * Used to parse each line of the log files
	 * Should return either false or a structure array
	 * false in the event of a non-match
	 * structure array depending on properties
	 */

	public $regexp_name		= '[A-z0-9_]{2,16}';
	public $regexp_ip		= '[0-9\.]+';
	public $regexp_coords	= '-?[0-9\.]+,\s*-?[0-9\.]+,\s*-?[0-9\.]+';
	
	private $appendable		= false;
	
	function parse_log_line($line){
		if(preg_match('/\[([0-9]{1,2}:[0-9]{1,2}:[0-9]{1,2})\]\s+\[([^\]]+)\]:\s+(.*?)$/i', $line, $matches)){
			$this->appendable = false;

			$time	= trim($matches[1]);
			$type	= strtolower(trim($matches[2]));
			$text	= trim($matches[3]);

			# [19:09:26] [Server thread/INFO]: [0;36;1mWild[0;32;1mTP [0;37;22m>> [0;31;1mSaved: [0;33;1m{}[m
			# [11:43:10] [Server thread/INFO]: [0;32;22m[WEB] John: [0;37;1mВозле магазина сундук )[m
			if($type=='server thread/info' && stripos($text, '[m[0;33;1m')!==false){
				$text = preg_replace('/^\[m\[0;33;1m/is', '', $text);
				$text = preg_replace('/\[m$/is', '', $text);
				if(strpos($text, '[m')!==false){
					list($user, $text) = explode('[m', $text);
					$return = array(
						'time'		=> $time,
						'type'		=> 'chat',
						'user'		=> trim($user),
						'text'		=> trim($text),
					);
					#echo '<pre>' . print_r($return, true) . '</pre>';
					return $return;
				}
			}
		}
		
		return false;
	}
}
