<?php
class db_store {

	#
	# Set
	# Insert parsed log row by type into correct table(s)
	#
	function set($data){

		# Type Required
		if(!isset($data['type'])){
			trigger_error('Type Required'); exit;
		}
		# Activity Insert
		else if(in_array($data['type'], array('chat', 'joined', 'left', 'error', 'warning', 'uuid', 'lag', 'command', 'info'))){
			if(!isset($data['server_id'])){
				trigger_error('Server ID Required'); exit;
			}
			if(!isset($data['log_id'])){
				trigger_error('Log ID Required'); exit;
			}
			$this->db->insert('log_activity', array(
					'server_id'		=> $data['server_id'], 
					'log_id'		=> $data['log_id'],
					'datetime'		=> (is_numeric($data['datetime']) ? date('Y-m-d H:i:s', $data['datetime']) : $data['datetime']),
					'activity'		=> $data['type'],
					'user_id'		=> null,
					'user_name'		=> (isset($data['user']) ? $data['user'] : null),
					'message'		=> $data['text'],	
				));

			if(isset($data['ip'])){
				$this->db->insert('log_activity', array(
						'server_id'		=> $data['server_id'], 
						'log_id'		=> $data['log_id'],
						'datetime'		=> (is_numeric($data['datetime']) ? date('Y-m-d H:i:s', $data['datetime']) : $data['datetime']),
						'activity'		=> 'ip',
						'user_id'		=> null,
						'user_name'		=> (isset($data['user']) ? $data['user'] : null),
						'message'		=> $data['ip'],	
					));
			}

			if(isset($data['coords'])){
				$this->db->insert('log_activity', array(
						'server_id'		=> $data['server_id'], 
						'log_id'		=> $data['log_id'],
						'datetime'		=> (is_numeric($data['datetime']) ? date('Y-m-d H:i:s', $data['datetime']) : $data['datetime']),
						'activity'		=> 'coords',
						'user_id'		=> null,
						'user_name'		=> (isset($data['user']) ? $data['user'] : null),
						'message'		=> json_encode($data['coords']),	
					));
			}
		}
		# Error
		else {
			trigger_error('Bad Type');
			echo '<pre>' . print_r($data, true) . '</pre>';
			exit;
		}
	}

	
}
