<?php

class ui {
	function render($data){
		header('Content-Type: application/json');
		header('Expires: ' . date('c', time() + 60));

		// Demo Data
		if(defined('PRIVACY_MODE') && PRIVACY_MODE===true){
			$data = $this->demodata('data', $data);
			#$data = $this->demonames('data', $data);
		}
		
		// Make sure sensitive metadata is not put to browser
		if(isset($data['server']['metadata'])){
			unset($data['server']['metadata']);
		}
		if(isset($data['servers'])){
			foreach($data['servers'] as $key=>$row){
				if(isset($data['servers'][$key]['metadata'])){
					unset($data['servers'][$key]['metadata']);
				}
			}
		}
		
		echo json_encode($data);
		exit;
	}

	/* ======================================================
	|	Just for Demo Mode
	*/

	private $names = array();
	
	function demodata($field, $value, $parent_path=array()){
	#	print_r($parent_path);
		if(is_array($value)){
			$parent_path[] = $field;
			foreach($value as $key=>$row){
				$value[$key] = $this->demodata($key, $row, $parent_path);
			}
		} else {
			if(stripos($field, 'ip')!==false){
				return preg_replace('/[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+/is', '000.000.000.000', $value);
			} else if(stripos($field, 'coord')!==false){
				return rand(-5000,5000) . ', ' . rand(1, 200) . ', ' . rand(-5000,5000);
			} else if(stripos($field, 'uuid')!==false){
				return 'xxxxxxxx-xxxx-0000-0000-012345678900';
			} else if(stripos($field, 'name')!==false && (count($parent_path)!=3 || (isset($parent_path[1]) && $parent_path[1]!='servers') ) ){
				if(!isset($this->names[$value])){
					$this->names[$value] = 'username' . count($this->names);	
				}

				return $this->names[$value];
			}
		}

		return str_replace(array_keys($this->names), $this->names, $value);
	}

	function demonames($field, $value){
		if(is_array($value)){
			foreach($value as $key=>$row){
				$value[$key] = $this->demonames($key, $row);
			}
		} else {
			return str_replace(array_keys($this->names), $this->names, $value);
		}

		return $value;
	}
}

