<?php
class dataset extends system_model {
	
	public $dataset = array();
	public $filters = array();
	
	function set_filters_by_segments($segments=array()){
		if(!isset($this->url_segment_map)){
			$this->url_segment_map = array_keys($segments);
		}
		
		// Map url segments to filter array
		// Ignore first segment
		foreach($this->url_segment_map as $index=>$field){
			$value = (isset($segments[$index+1]) ? $segments[$index+1] : false);
			#echo $index . ':' . $field . ' = ' . $value . '<br />';
			if($field=='date'){
				if(trim($value)!=''){
					$date = strtotime($value);
				} else {
					$date = time();
				}

				$this->filters['date_from_unix'] = mktime(0, 0, 0, date('m', $date), date('d', $date), date('Y', $date));
				$this->filters['date_from'] = date('Y-m-d H:i:s', $this->filters['date_from_unix']);
				$this->filters['date_stop_unix'] = mktime(23, 59, 59, date('m', $date), date('d', $date), date('Y', $date));
				$this->filters['date_stop'] = date('Y-m-d H:i:s', $this->filters['date_stop_unix']);
			} else if($field=='daterange'){
				$from = null;
				$stop = null;
				
				# Range indicated by underscore
				if(strpos($value, '_')!==false){
					list($from, $stop) = explode('_', $value);
					$from = strtotime($from);
					$stop = strtotime($stop);
				} else {
					$stop = strtotime($value);
				}
				if($stop===null || !($stop>86400)){
					$stop = time();
				}
				if($from===null){
					$from = mktime(23, 59, 59, date('m', $stop)-1, date('d', $stop), date('Y', $stop));;
				}
				
				$this->filters['date_from_unix'] = mktime(0, 0, 0, date('m', $from), date('d', $from), date('Y', $from));
				$this->filters['date_from'] = date('Y-m-d H:i:s', $this->filters['date_from_unix']);
				$this->filters['date_stop_unix'] = mktime(23, 59, 59, date('m', $stop), date('d', $stop), date('Y', $stop));
				$this->filters['date_stop'] = date('Y-m-d H:i:s', $this->filters['date_stop_unix']);
			} else {
				$this->filters[$field] = $value;
			}
		}
		
	}
	
	function set($label, $value){
		$this->dataset[$label] = $value;
	}
	
}
