<?php
class dataset_analytics extends dataset {
	public $url_segment_map = array(
		'server_id',
		'daterange',
		'groupby'
	);
	
	function get(){
		$return = array();
		
		// Group
		if(!isset($this->filters['groupby']) || !in_array($this->filters['groupby'], array('day', 'week', 'month', 'year'))){
			$this->filters['groupby'] = 'day';
		}
		
		// Build Graph points
		$return['visits'] = array();
		$i = $this->filters['date_from_unix'];
		while($i<=$this->filters['date_stop_unix']){
				$row['date_unix'] = $i;
				if($this->filters['groupby']=='week'){
					$datekey = date('Y-W', $row['date_unix']);
					$i += 86400*7;
				} else if($this->filters['groupby']=='month'){
					$datekey = date('Y-m', $row['date_unix']);
					$i = mktime(0, 0, 0, date('m', $row['date_unix'])+1, date('d', $row['date_unix']), date('Y', $row['date_unix']));
				} else if($this->filters['groupby']=='year'){
					$datekey = date('Y', $row['date_unix']);
					$i = mktime(0, 0, 0, date('m', $row['date_unix']), date('d', $row['date_unix']), date('Y', $row['date_unix'])+1);
				} else {
					$datekey = date('Y-m-d', $row['date_unix']);
					$i += 86400;
				}
				#echo $datekey . "<br />\n";
				$return['visits'][$datekey] = array(
					'date'		=> encode_datetime($row['date_unix']),
					'visits'	=> 0,
					'players'	=> 0,
					'playtime'	=> 0,
					'activity'	=> array(),
				);
		}
		
		// Player Activity
		$sql = "SELECT UNIX_TIMESTAMP(a1.datetime) AS date_unix, a1.activity, a1.user_name, a1.message
			FROM log_activity a1
			WHERE a1.datetime BETWEEN '" . $this->filters['date_from'] . "' AND '" . $this->filters['date_stop'] . "'
				AND a1.activity IN ('joined', 'left')
			
		";
		
		if(isset($this->dataset['server']['id']) && (int)$this->dataset['server']['id']>0){
			$sql .= " AND a1.server_id=" . (int)$this->dataset['server']['id'] . "";
			$sql .= " ORDER BY a1.datetime ASC";
		} else {
			$sql .= " ORDER BY a1.server_id ASC, a1.datetime ASC";
		}
		
		
		foreach($this->db->query($sql) as $row){
			#echo date('Y-m-d', $row['date_unix']) . "<br />\n";
			#echo '<pre>' . print_r($row, true) . '</pre>';
			
			if($this->filters['groupby']=='week'){
				$datekey = date('Y-W', $row['date_unix']);
			} else if($this->filters['groupby']=='month'){
				$datekey = date('Y-m', $row['date_unix']);
			} else if($this->filters['groupby']=='year'){
				$datekey = date('Y', $row['date_unix']);
			} else {
				$datekey = date('Y-m-d', $row['date_unix']);
			}
			$userkey = $row['user_name'];
			
			
			# Create a missing row
			if(!isset($return['visits'][$datekey])){
				$return['visits'][$datekey] = array(
					'date'		=> encode_datetime($row['date_unix']),
					'visits'	=> 0,
					'players'	=> 0,
					'playtime'	=> 0,
					'activity'	=> array(),
				);
			}
			
			# User
			if(!isset($return['visits'][$datekey]['activity'][$userkey])){
				$return['visits'][$datekey]['players']++;
				$return['visits'][$datekey]['activity'][$userkey] = array(
								'login'			=> $row['date_unix'],
								'playtime'	=> 0,
							);
			} else {

			}
			
			# User Joined
			if($row['activity']=='joined'){
				$return['visits'][$datekey]['visits']++;
				$return['visits'][$datekey]['activity'][$userkey]['login'] = $row['date_unix'];
			}
			# User Left
			else if($row['activity']=='left'){
				
				if(isset($return['visits'][$datekey]['activity'][$userkey]['login'])){
					$return['visits'][$datekey]['activity'][$userkey]['playtime'] = $row['date_unix'] - $return['visits'][$datekey]['activity'][$userkey]['login'];
					unset($return['visits'][$datekey]['activity'][$userkey]['login']);
				} else {
					$return['visits'][$datekey]['activity'][$userkey]['playtime'] = $row['date_unix'] - mktime(0, 0, 0, date('m', $row['date_unix']), date('d', $row['date_unix']), date('Y', $row['date_unix']));
				}
			}
		}
		
		# Post process
		foreach($return['visits'] as $key=>$row){
			foreach($return['visits'][$key]['activity'] as $activity){
				if(isset($activity['login'])){
					if(date('Ymd', $activity['login'])==date('Ymd')){
						$activity['playtime'] += time() - $activity['login'];
					} else {
						$time = mktime(23, 59, 59, date('m', $activity['login']), date('d', $activity['login']), date('Y', $activity['login']));
						$activity['playtime'] += $time - $activity['login'];
					}
				}
				
				$return['visits'][$key]['playtime'] += $activity['playtime'];
			}
			
			unset($return['visits'][$key]['activity']);
		}
		
		
		# Return
		
		$return['filters'] = array(
							'groupby'	=> $this->filters['groupby'],
							'date'		=> array(
										'from'	=> date('c' , $this->filters['date_from_unix']),
										'stop'	=> date('c' , $this->filters['date_stop_unix']),
									)
				);
		
		return $return;
	}
}
