<?php
class dataset_logs extends dataset {
	function get(){
		$return = array();
		
		# List Logs
		$sql = "SELECT log_id, datetime_file, file_name, status, lines_parsed, lines_counted
			FROM log_index
			WHERE server_id=" . (int)$this->dataset['server']['id'] . "
			ORDER BY datetime_file DESC
		";

		$return['logs'] = array();
		foreach($this->db->query($sql) as $row){
			$return['logs'][$row['log_id']] = $row;
		}

		# Stats: Activity
		$sql = "SELECT log_id, activity, COUNT(activity) AS counted
			FROM log_activity
			WHERE server_id=" . (int)$this->dataset['server']['id'] . "
				AND activity IN ('chat', 'joined', 'left')
				AND NOT user_name IS NULL
			GROUP BY log_id, activity
		";

		foreach($this->db->query($sql) as $row){
			$return['logs'][$row['log_id']]['activity'][$row['activity']] = $row['counted'];
		}

		# Stats: Activity
		$sql = "SELECT log_id, COUNT(DISTINCT user_name) AS counted
			FROM log_activity
			WHERE server_id=" . (int)$this->dataset['server']['id'] . "
				AND NOT user_name IS NULL
			GROUP BY log_id
		";

		foreach($this->db->query($sql) as $row){
			$return['logs'][$row['log_id']]['activity']['users'] = $row['counted'];
		}

		$return['logs'] = array_values($return['logs']);
		
		
		# Return
		return $return;
	}
}
