<?php
class dataset_users extends dataset {
	public $url_segment_map = array(
		'action',
		'search_string',
	);
	
	function get(){
		$return = array();
		
		# Action: Search
		if($this->filters['action']=='search' && trim($this->filters['search_string'])!=''){
			$sql = "SELECT CASE WHEN activity='ip' THEN message ELSE user_name END AS str, user_name
				, activity
				, MAX(datetime) AS datetime";
			$sql .= " 
				FROM log_activity ";

			
			$sql .= " WHERE (
						(activity='joined' AND user_name LIKE '%" . $this->db->escape_like($this->filters['search_string']) . "%')
							OR
						(activity='ip' AND message LIKE '%" . $this->db->escape_like($this->filters['search_string']) . "%')
					)";
			

			$sql .= " 
				GROUP BY user_name
				ORDER BY user_name ASC
				";

			$return['users'] = array();
			foreach($this->db->query($sql) as $row){
				$return['users'][] = $row;
			}
			$return['filters']['search_string']	= $this->filters['search_string'];
		}
		# Action: Get user by name
		else if($this->filters['action']=='name' && trim($this->filters['search_string'])!=''){
			$return['user'] = array();
			
			# UUID
			$sql = "
				SELECT DISTINCT message 
				FROM log_activity 
				WHERE activity='uuid' AND user_name=" . $this->db->escape($this->filters['search_string']) . "
			";
			$return['user']['uuid'] = array();
			foreach($this->db->query($sql) as $row){
				$return['user']['uuid'][] = $row['message'];
			}
			
			# Aliases
			$name_sql = array();
			$sql = "SELECT DISTINCT user_name, MIN(datetime) AS datetime_min, MAX(datetime) AS datetime_max
				FROM log_activity 
				WHERE activity='uuid' AND message IN ('" . implode("','", $return['user']['uuid']) . "')
				GROUP BY user_name
				ORDER BY datetime DESC
			";
			$return['user']['aliases'] = array();
			foreach($this->db->query($sql) as $row){
				$name_sql[] = $this->db->escape($row['user_name']);
				$return['user']['aliases'][] = $row;
			}
			if(count($name_sql)>0){
				$where_user = 'user_name IN (' . implode(", ", $name_sql) . ')';
			} else {
				$where_user = 'FALSE';
			}
			
			# IPs
			$sql = "SELECT message AS ip, MIN(datetime) AS datetime_min, MAX(datetime) AS datetime_max
				FROM log_activity 
				WHERE activity='ip' AND " . $where_user . "
				GROUP BY message
				ORDER BY datetime DESC
			";
			$return['user']['ips'] = array();
			foreach($this->db->query($sql) as $row){
				$return['user']['ips'][] = $row;
			}
			
			# Player Meta
			$sql = "SELECT meta, user_name, date1 AS date, value1, value2, value3
				FROM player_meta
				WHERE " . $where_user . "
				ORDER BY meta ASC
			";
			$return['user']['meta'] = array();
			foreach($this->db->query($sql) as $row){
				$return['user']['meta'][] = $row;
			}
			
			# Chat
			$sql = "SELECT message, datetime
				FROM log_activity 
				WHERE activity='chat' AND " . $where_user . "
				ORDER BY datetime DESC
				LIMIT 50
			";
			$return['user']['chat'] = array();
			foreach($this->db->query($sql) as $row){
				$return['user']['chat'][] = $row;
			}
			
			# Detail
			$sql = "SELECT user_name, MIN(datetime) AS datetime_min, MAX(datetime) AS datetime_max
				FROM log_activity 
				WHERE " . $where_user . "
				GROUP BY user_name
				ORDER BY datetime DESC
			";
			$result = $this->db->fetch($sql);
			if(isset($result['user_name'])){
				$return['user']['details'] = $result;
			}
			$return['filters']['search_string']	= $this->filters['search_string'];
		}
		# Action: Get user by IP
		else if($this->filters['action']=='ip' && trim($this->filters['search_string'])!=''){
			$return['user'] = array();
			$where_user = array();
			
			# Aliases
			$sql = "SELECT DISTINCT user_name, MIN(datetime) AS datetime_min, MAX(datetime) AS datetime_max
				FROM log_activity 
				WHERE activity='ip' AND message=" . $this->db->escape(trim($this->filters['search_string'])) . "
				GROUP BY user_name
				ORDER BY datetime DESC
			";
			$return['user']['aliases'] = array();
			foreach($this->db->query($sql) as $row){
				$return['user']['aliases'][] = $row;
			}
			$return['filters']['search_string']	= $this->filters['search_string'];
		}
		
		# Return
		$return['filters']['action']	= $this->filters['action'];
		return $return;
	}
}
